/**
 * Copyright 2013 Parallel Data Lab (Carnegie Mellon University)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * @file emuerror.h
 *
 * @brief Defines error codes associated with the emulator.
 *
 * @author Anand Suresh <anandsuresh@cmu.edu>
 *
 * @bug No known bugs
 */

#ifndef __EMUERROR_H_
#define __EMUERROR_H_


/* -- Macro Definitions -- */
#define BASE_ERROR_CODE 1 << 15

/* Error Codes */
#define EINVALIDFILE    BASE_ERROR_CODE | 0
#define EUNSUPPORTED    BASE_ERROR_CODE | 1
#define EFAIL                   BASE_ERROR_CODE | 2
#define EBAND                   BASE_ERROR_CODE | 3
#define ERBA                    BASE_ERROR_CODE | 4
#define EOOB                    BASE_ERROR_CODE | 5
#define EUPDATE                 BASE_ERROR_CODE | 6
#define EVERSION                BASE_ERROR_CODE | 7



#endif      /* __EMUERROR_H_ */
